<script lang="ts">
    let container: HTMLElement

    const handleMove = (e: MouseEvent) => {
        let x = e.pageX - container.offsetLeft - container.offsetWidth / 2
        let y = e.pageY - container.offsetTop - container.offsetHeight / 2

        container.querySelectorAll('*[data-factor]').forEach((layer: HTMLElement) => {
            const factor = parseFloat(layer.dataset.factor)
            x = -x * factor
            y = -y * factor
            layer.style.transform = `translate3d(${x}px, ${y}px, 0)`
        })
    }

    const handleLeave = (e: MouseEvent) => {
        container.querySelectorAll('*[data-factor]').forEach((layer: HTMLElement) => {
            layer.style.transform = 'translate3d(0px, 0px, 0)'
            e.stopPropagation()
        })
    }
</script>

<div
    bind:this={container}
    class="parallax-container"
    on:mouseleave={handleLeave}
    on:mousemove={handleMove}
>
    <slot />
</div>

<style lang="postcss">
    .parallax-container {
        @apply h-full;
    }
</style>
